#include "rose.h"
// #include "sageInterface.h"
#include <sstream>
using namespace std;


/*
*/

// parse the constant name 

int get_num_value(SgNode* sgNode)
{
  SgValueExp* varRef = isSgValueExp(sgNode);
    
  switch(varRef->variantT()) {
  case V_SgIntVal:
    return isSgIntVal(varRef)->get_value();
  case V_SgUnsignedIntVal:
    return isSgUnsignedIntVal(varRef)->get_value();
  case V_SgBoolValExp:
    return isSgBoolValExp(varRef)->get_value();
  //edited by Hongyi
  // try to support float doube in static analysis, previous translated them in to int, since yices does not support non-int 
   case V_SgFloatVal:
        {
        ostringstream out;
        std::cout << isSgFloatVal(varRef)->get_value();
   //   return out.str();
        return 0; // does not support
        }
      case V_SgDoubleVal:
        {
          ostringstream out;
         std::cout << isSgDoubleVal(varRef)->get_value();
  //    return out.str();
         return 0; //does not support
        }
    default:
      return 0;
    }
}

bool is_shared_var(SgInitializedName* initializedName)
{
  SgDeclarationStatement* decl = initializedName->get_declaration();
  // cout << "decl: " << decl->unparseToString() << endl;
  // currently we detected them with ompcheckinterface.h, local, global defintions and private, shared clasue
   // test DeclarationStatement whether it is in global.
  string::size_type loc = decl->unparseToString().find("volatile", 0);
  return (loc != string::npos); 

  // the following doesn't work for array variables
  /*
  SgType* type = initializedName->get_type();
  // printf ("   initializedName: type = %p = %s \n",type,type->class_name().c_str());
  SgModifierType* modifierType = isSgModifierType(type);
  if (modifierType != NULL)
    return modifierType->get_typeModifier().get_constVolatileModifier().isVolatile();
  return false;
  */
}


  // cout << "decl: " << decl->unparseToString() << endl;

  /*
  SgType* type = initializedName->get_type();
  // printf ("   initializedName: type = %p = %s \n",type,type->class_name().c_str());
  SgModifierType* modifierType = isSgModifierType(type);
  if (modifierType != NULL)
    return modifierType->get_typeModifier().get_constVolatileModifier().isConst();
  return false;
  */

bool is_const_var(SgInitializedName* initializedName)
{
  SgDeclarationStatement* decl = initializedName->get_declaration();
  return SageInterface::isStatic(decl);
}

/* function modifiers
*/

bool is_check_func(SgFunctionDeclaration* functionDeclaration)
{
  // all the functionCalls are inlined before encoding
  return functionDeclaration->get_functionModifier().isInline();
//  {
   //test 
  //  return true;
//  }
}
 

bool is_global_func(SgFunctionDeclaration* functionDeclaration)
{
  return SageInterface::isStatic(functionDeclaration);
}

bool is_host_func(SgFunctionDeclaration* functionDeclaration)
{
  return SageInterface::isExtern(functionDeclaration);
}

// this part is to check variable attributes from interface.h
void query_variables (SgProject *project) {
  Rose_STL_Container<SgNode*> variableList = NodeQuery::querySubTree (project,V_SgInitializedName);

  int counter = 0;
  for (Rose_STL_Container<SgNode*>::iterator i = variableList.begin(); i != variableList.end(); i++)
    {

      SgInitializedName* initName = isSgInitializedName(*i);
      ROSE_ASSERT(initName != NULL);
      if (is_shared_var(initName)) 
	cout << "Found shared variable: " << initName->get_name().str() << endl;
       else if (is_const_var(initName)) 
	cout << "Found const variable: " << initName->get_name().str() << endl;
       else
         {
          // edited by Hongyi, some private variables also cause non-determin...
         }
      }
}

//edited by Hongyi, test whcih variables are interested in encoding
void query_allVariables(SgProject *project) {
  Rose_STL_Container<SgNode*> variableList = NodeQuery::querySubTree (project, NodeQuery::VariableDeclarations);

  int counter = 0;
  for (Rose_STL_Container<SgNode*>::iterator i = variableList.begin(); i != variableList.end(); i++)
    {
      SgVariableDeclaration* varDeclaration = isSgVariableDeclaration(*i);
      SgInitializedName* initializedName = isSgInitializedName(*i);
      ROSE_ASSERT(initializedName != NULL);
      printf ("Found a SgInitializedName = %s \n",initializedName->get_name().str());
      
    }
}

 
//edited by Hongyi
// test which kind of functions are interested in encoding 
void query_functions (SgProject *project) {
  Rose_STL_Container<SgNode*> functionDeclarationList = NodeQuery::querySubTree (project,V_SgFunctionDeclaration);

  int counter = 0;
  for (Rose_STL_Container<SgNode*>::iterator i = functionDeclarationList.begin(); i != functionDeclarationList.end(); i++)
    {
      // Build a pointer to the current type so that we can call the get_name() member function.
      SgFunctionDeclaration* functionDeclaration = isSgFunctionDeclaration(*i);
      ROSE_ASSERT(functionDeclaration != NULL);
      
      if ( functionDeclaration->get_file_info()->isCompilerGenerated() == false) {
       if (is_check_func(functionDeclaration)) 
	cout << "Found check functions : " << functionDeclaration->get_name().str() << endl;
       else if (is_global_func(functionDeclaration)) 
	cout << "Found global functions : " << functionDeclaration->get_name().str() << endl;
       else if (is_host_func(functionDeclaration)) 
	cout << "Found host functions : " << functionDeclaration->get_name().str() << endl;
      }
    }
}


void identify_shared_variables(SgProject* project, set<string>& sharedVars) {
  Rose_STL_Container<SgNode*> variableList = NodeQuery::querySubTree (project,V_SgInitializedName);

  for (Rose_STL_Container<SgNode*>::iterator i = variableList.begin(); i != variableList.end(); i++)
    {

      SgInitializedName* initName = isSgInitializedName(*i);
      ROSE_ASSERT(initName != NULL);
      if (is_shared_var(initName)) {
	cout << "Found shared variable: " << initName->get_name().str() << endl;
	sharedVars.insert(initName->get_name().str());
      }
    }
}


/********************************************************************************
 *******************************************************************************/

/*
template<typename T> 
std::set<T> union_set(std::set<T>& s1, std::set<T>& s2) {
  std::set<T> s;

  for (typename std::set<T>::iterator ii = s1.begin(); ii != s1.end(); ii++) {
    s.insert(*ii);
  }
  for (typename std::set<T>::iterator ii = s2.begin(); ii != s2.end(); ii++) {
    s.insert(*ii);
  }
  return s;
}

*/
