#ifndef __MY_UTIL__
#define __MY_UTIL__

#include "rose.h"

int get_num_value(SgNode* sgNode);

// shared varable may cause data race.
bool is_shared_var(SgInitializedName* initializedName);
//
//edited by Hongyi,
// this part can be utilzied by ompCheckerInterface for private and shared clause list.


bool is_const_var(SgInitializedName* initializedName);
bool is_global_var(SgInitializedName* initializedName);
bool is_local_var(SgInitializedName* initialzedName);

// functions we interested 
bool is_check_func(SgFunctionDeclaration* functionDeclaration);
bool is_global_func(SgFunctionDeclaration* functionDeclaration);
// since oopenmp is inside MPI rank, so MPI rank is global or is  omp statement block.

bool is_host_func(SgFunctionDeclaration* functionDeclaration);


void identify_shared_variables (SgProject* project, std::set<std::string>& sharedVars);

void query_variables (SgProject *project);
void query_functions (SgProject *project);

// template<typename T> std::set<T> union_set(std::set<T>& s1, std::set<T>& s2);

class Config {
 public:
 
  // partial order reduction
  static bool use_POR; 
  // hybrid mode 
  static bool use_mpiomp;  
 
  Config() {
  }
};

#endif
